//#include "stdafx.h"
#include "CpuUsage.h"

// ***************************************************************************************

CCpuUsage::CCpuUsage()
{
	NtQuerySystemInformation = (PROCNTQSI)GetProcAddress(GetModuleHandle("ntdll"),"NtQuerySystemInformation");
    if (!NtQuerySystemInformation) { m_error=TRUE; return; }
	m_error=FALSE;

    // get number of processors in the system
    status = NtQuerySystemInformation(SystemBasicInformation,&SysBaseInfo,sizeof(SysBaseInfo),NULL);
    if (status != NO_ERROR) { m_error=TRUE; return; }

	liOldIdleTime.LowPart =0;
	liOldIdleTime.HighPart =0;
	liOldSystemTime.LowPart=0;
	liOldSystemTime.HighPart=0;
}

// ***************************************************************************************

CCpuUsage::~CCpuUsage()
{
}

// ***************************************************************************************

int CCpuUsage::Get(char *process)
{
    // get new system time
	status = NtQuerySystemInformation(SystemTimeInformation,&SysTimeInfo,sizeof(SysTimeInfo),NULL);
    if (status!=NO_ERROR) return 0;
    // get new CPU's idle time
    status = NtQuerySystemInformation(SystemPerformanceInformation,&SysPerfInfo,sizeof(SysPerfInfo),NULL);
    if (status != NO_ERROR) return 0;

    // if it's a first call - skip it
   if (liOldIdleTime.QuadPart)
   {
        // CurrentValue = NewValue - OldValue
        dbIdleTime = Li2Double(SysPerfInfo.liIdleTime) - Li2Double(liOldIdleTime);
        dbSystemTime = Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(liOldSystemTime);

        // CurrentCpuIdle = IdleTime / SystemTime
        dbIdleTime = dbIdleTime / dbSystemTime;

        // CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
        dbIdleTime = 100.0 - dbIdleTime * 100.0 / (double)SysBaseInfo.bKeNumberProcessors + 0.5;
   }

    // store new CPU's idle and system time
    liOldIdleTime = SysPerfInfo.liIdleTime;
    liOldSystemTime = SysTimeInfo.liKeSystemTime;
	return (int)dbIdleTime;
}
