#if !defined(AFX_GETCPUUSAGE1_H__EB4F7708_88C4_4839_9AA0_6A57E33999B5__INCLUDED_)
#define AFX_GETCPUUSAGE1_H__EB4F7708_88C4_4839_9AA0_6A57E33999B5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// ***************************************************************************************

#include "winternl.h"

#define SystemBasicInformation       0
#define SystemPerformanceInformation 2
#define SystemTimeInformation        3

#define Li2Double(x) ((double)((x).HighPart) * 4.294967296E9 + (double)((x).LowPart))

// ***************************************************************************************

typedef struct
{
    DWORD   dwUnknown1;
    ULONG   uKeMaximumIncrement;
    ULONG   uPageSize;
    ULONG   uMmNumberOfPhysicalPages;
    ULONG   uMmLowestPhysicalPage;
    ULONG   uMmHighestPhysicalPage;
    ULONG   uAllocationGranularity;
    PVOID   pLowestUserAddress;
    PVOID   pMmHighestUserAddress;
    ULONG   uKeActiveProcessors;
    BYTE    bKeNumberProcessors;
    BYTE    bUnknown2;
    WORD    wUnknown3;
} SYSTEM_BASIC_INFORMATION;

typedef struct
{
    LARGE_INTEGER   liIdleTime;
    DWORD           dwSpare[76];
} SYSTEM_PERFORMANCE_INFORMATION;

typedef struct
{
    LARGE_INTEGER liKeBootTime;
    LARGE_INTEGER liKeSystemTime;
    LARGE_INTEGER liExpTimeZoneBias;
    ULONG         uCurrentTimeZoneId;
    DWORD         dwReserved;
} SYSTEM_TIME_INFORMATION;

typedef LONG (WINAPI *PROCNTQSI)(UINT,PVOID,ULONG,PULONG);

// ***************************************************************************************

class CCpuUsage  
{
	public:
		PROCNTQSI NtQuerySystemInformation;

	private:
		BOOL m_error;
		SYSTEM_PERFORMANCE_INFORMATION SysPerfInfo;
		SYSTEM_TIME_INFORMATION        SysTimeInfo;
		SYSTEM_BASIC_INFORMATION       SysBaseInfo;
		double                         dbIdleTime;
		double                         dbSystemTime;
		LONG                           status;
		LARGE_INTEGER                  liOldIdleTime;
		LARGE_INTEGER                  liOldSystemTime;
	
	public:
		int Get(char *process=NULL);
		CCpuUsage();
		virtual ~CCpuUsage();

};

#endif // !defined(AFX_GETCPUUSAGE1_H__EB4F7708_88C4_4839_9AA0_6A57E33999B5__INCLUDED_)
