#include <windows.h>
#include <stdio.h>

#include "MyBrowseFile.h"

/* *************************************************************************************************
	Callback de la BouseFile: place le brouser dans un repertoire pas default
************************************************************************************************* */

int CALLBACK MyBrowseCallbackProc (HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	 switch (uMsg) 
	 {
		 case BFFM_INITIALIZED :
			 LPITEMIDLIST  pidl;
			 LPSHELLFOLDER pDesktopFolder;
			 char *TheFolder = (char *)lpData;
			 OLECHAR olePath[MAX_PATH] ;
			 ULONG chEaten;
			 ULONG dwAttributes;
			 HRESULT hr;

			 SHGetDesktopFolder(&pDesktopFolder) ;			 

			 MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, TheFolder, -1,olePath, MAX_PATH);
			 hr = pDesktopFolder->ParseDisplayName(NULL,NULL,olePath,&chEaten,&pidl,&dwAttributes);

			 SendMessage(hwnd, BFFM_SETSELECTION, FALSE, (LPARAM)pidl) ;
			 break ;
	 }
	 return 0;
}

/* *************************************************************************************************
ex : BrowseFile bf("lecture d'un bitmap",TYPE_FILE_OPEN,"bitmap Files (*.bmp)\0*.bmp\0",NULL);
ex : BrowseFile bf("lecture d'un bitmap",TYPE_FILE_SAVE,"bitmap Files (*.bmp)\0*.bmp\0","bmp");
ex : BrowseFile bf("repertoire d'instal",TYPE_REP,"c:\\",NULL);
************************************************************************************************* */

CMyBrowseFile::CMyBrowseFile(HWND hWndMain,char *title,int type,char *option1,char *option2)
{
    bool Good = false;
	char ErrMsg[MAX_PATH];
	result[0]='\0';
	ITEMIDLIST *idl;

	switch (type)
	{
		// dans un repertoire [IN] title,option1(repdep) [OUT] isOk, result   
		case TYPE_REP:
			if (option1) strcpy(result,option1); // rep de depart dans option1
			ZeroMemory(&m_bi, sizeof(m_bi));
			m_bi.hwndOwner = hWndMain;
			m_bi.pidlRoot  = NULL; 
			m_bi.pszDisplayName = result; 
			m_bi.lpszTitle	= title; 
			m_bi.ulFlags = BIF_BROWSEINCLUDEFILES ;  
			m_bi.lpfn    = MyBrowseCallbackProc; // NULL; //pour commence a la racine 
			m_bi.lParam = (LPARAM)result; //
			m_bi.iImage  = 0	; 
			
			idl = SHBrowseForFolder (&m_bi);
			if (idl == NULL) isOk = false;
			else isOk = true;
			ErrMsg[0] = 0 ;
			SHGetPathFromIDList (idl, result);	
			LPMALLOC lpm;

			if (SHGetMalloc (&lpm) == NOERROR) 	lpm->Free(idl);    
			break;

		// ouverture d'un fichier [IN] title,option1,option2 [OUT] isOk, result
		case TYPE_FILE_OPEN:
			 ZeroMemory(&m_ofn, sizeof(m_ofn));
 
			 m_ofn.lStructSize = sizeof(m_ofn);
			 m_ofn.hwndOwner = hWndMain;		//hWnd; file://handle to your window
			 m_ofn.lpstrFilter = option1;	// = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
			 m_ofn.lpstrFile = result;
			 m_ofn.nMaxFile = MAX_PATH;
			 m_ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			 m_ofn.lpstrTitle = title; 
 
			 if( GetOpenFileName( &m_ofn ) )
			  {
			     isOk = true;
				 strcpy( result, m_ofn.lpstrFile );
			  }
			 else isOk = false;

			break;

		// sauvegarde d'un fichier [IN] title,option1,option2 [OUT] isOk, result
		case TYPE_FILE_SAVE:
			 ZeroMemory(&m_ofn, sizeof(m_ofn));
 
			 m_ofn.lStructSize = sizeof(m_ofn);
			 m_ofn.hwndOwner = hWndMain; //hWnd; file://handle to your window
			 m_ofn.lpstrFilter = option1;// = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
			 m_ofn.lpstrFile = result;
			 m_ofn.nMaxFile = MAX_PATH;
			 m_ofn.lpstrDefExt = option2;
			 m_ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
 
			 if( GetSaveFileName( &m_ofn ) )
			  {
			     isOk = true;
				 strcpy( result, m_ofn.lpstrFile );
			  }
			 else isOk = false;
			break;

	}
}		
 
// *************************************************************************************************

CMyBrowseFile::~CMyBrowseFile()
{
}

// *************************************************************************************************

void CMyBrowseFile::GetResult(char *res)
{
	strcpy (res,result);
}

// *************************************************************************************************
// *************************************************************************************************
