// listView.h: interface for the CMyListView class.
//
//////////////////////////////////////////////////////////////////////
#include <commctrl.h>

#if !defined(AFX_LISTVIEW_H__E03DD901_8FF2_11D5_9AB9_00D04C390250__INCLUDED_)
#define AFX_LISTVIEW_H__E03DD901_8FF2_11D5_9AB9_00D04C390250__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* **********************************************************************************
	Ajouter la comctl32.lib dans les link
********************************************************************************** */

#include "MyControl.h"
#include "MyList.h"
#include "MyTree.h"

#define DEBUG_LISTVIEW // a masquer si l'on ne desire pas de debug

#include "ClientDebug.h"

class CMyListViewNotify
{
	private:
	#ifdef DEBUG_LISTVIEW
		CMyString titleDebug,textDebug;
		CClientDebug debug;
	public:
		HWND hWnd;
	#endif

	protected:
		virtual void OnColumnSizeChanged (int numColumn,int newSize);
		virtual void OnGetText (int line,int column,char *text);
		virtual void OnItemChanged (int line,int column);
		virtual void OnKeyDown (WORD vKey);

		friend class CMyListView;
};

class CMyListView : public CMyControl , public CMyListViewNotify
{
	private:
		CMyListViewNotify *classNotify;
		int m_lineSelected;
		int m_columnSelected;

		int oldColumn; // pour la detection de changement de colone
		int oldWidth;
		BOOL isRepaint ;

	public:
		CMyListView			(HWND hwndMaster,int x,int y,int xy,int dy,int optionalControlID=0);
		CMyListView			(HWND hwndListView);
		CMyListView			();
		virtual ~CMyListView();
		void operator=		(HWND hWndListView);
		void operator=		(CMyListViewNotify *ptrClassNotify);

		int		 GetLineSelected	()	{return m_lineSelected;}
		int		 GetColumnSelected	()	{return m_columnSelected;}

		BOOL	 AddColumn			(char *nameHead,int size);
		BOOL	 AddColumnPercent   (char *nameHead,double percent);
		void	 SetNbCount			(int nbCount);
		int		 GetNbCount			() { return m_nbCount; }
		void	 IncCount			() { SetNbCount(m_nbCount+1); }
		void	 DecCount			() { SetNbCount(m_nbCount-1); }

		void	 UnSelectedAll		();
		void	 SetLineSelected	(int index,BOOL alwaysOneSelected=TRUE);
		void	 EnableLineSelected	(int index,BOOL set);

		BOOL	 IsLineSelected		(int index);
		void	 SetHotItem			(int index);

		int		 GetColumnWidth		(int index);
		BOOL	 SetColumn			(long index,char *text);

		void	 SetGridLinesView	(BOOL active);
		BOOL	 SetImageList		(HIMAGELIST hil);

		BOOL	 GetFullRawSelect	();
		BOOL	 SetFullRawSelect	(BOOL set);

		int		GetLinesSelected	(CMyList<int> *lstSelect);

		void	SetLineHover		(int newLine) { m_lineHover=newLine; }
		int		GetLineHover		() { return m_lineHover; }
		void	SetColumnHover		(int newLine) { m_columnHover=newLine; }
		int		GetColumnHover		() { return m_columnHover; }

		BOOL	Notify				(LPARAM lParam,int *result);

		BOOL	SetItemHeight		(int height);
		BOOL	SetCheckBox			(BOOL set);
		BOOL	SetHeaderDragDrop	(BOOL set);
		BOOL	SetSubItemImages	(BOOL set);
		BOOL	SetTrackSelect		(BOOL set);

		HWND	GetHeader			();

		void	SetHightLightColor			(COLORREF textColor,COLORREF backgroundColor);
		void	SetHightLightColorUnFocus	(COLORREF textColor,COLORREF backgroundColor);
		void	SetLineColor				(COLORREF textColor,COLORREF backgroundColor);

		void	GetHightLightColor			(COLORREF *textColor,COLORREF *backgroundColor);
		void	GetHightLightColorUnFocus	(COLORREF *textColor,COLORREF *backgroundColor);
		void	GetLineColor				(COLORREF *textColor,COLORREF *backgroundColor);

		int		GetControlID		() { return m_controlID; }

		void	FirstCollumnAsTree		(CMyTree *tree);
		void	TreeColumnSizeChanged	();

		CMyTree	*	m_tree;

	private:
		void		Init();

		int			m_nbCount;
		int			m_nbColumn;

		int			m_lineHover;
		int			m_columnHover;

		COLORREF	m_textColor;		
		COLORREF 	m_backgroundColor;
		COLORREF	m_textColorHi;		
		COLORREF 	m_backgroundColorHi;
		COLORREF	m_textColorHiUf;		
		COLORREF 	m_backgroundColorHiUf;

		int			m_controlID;
};

#endif // !defined(AFX_LISTVIEW_H__E03DD901_8FF2_11D5_9AB9_00D04C390250__INCLUDED_)
