#if !defined(AFX_TITLEMENU_H__E69DD9C2_0FDA_11D6_9385_0060086FAC36__INCLUDED_)
#define AFX_TITLEMENU_H__E69DD9C2_0FDA_11D6_9385_0060086FAC36__INCLUDED_

#include "myString.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Issue de http://www.codeproject.com/menu/titlemenu.asp
/* Example *******************************************************************************

LRESULT CALLBACK TestProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CMyMenu menu;

	switch (message)
	{
		case WM_INIT:
			menu = LoadMenu(hInst,MAKEINTRESOURCE(IDM_MAIN));
			menu.AddTitle("Mon titre");
			return TRUE;

		case WM_MEASUREITEM:
			menu.MeasureItem((LPMEASUREITEMSTRUCT)lParam);
			return TRUE;

		case WM_DRAWITEM:
			menu.DrawItem((LPDRAWITEMSTRUCT)lParam);
			return TRUE;
	}
    return FALSE;
}

*************************************************************************************** */

#include "windows.h"

class CMyMenu 
{
	typedef UINT (CALLBACK* LPFNDLLFUNC1)(HDC,CONST PTRIVERTEX,DWORD,CONST PVOID,DWORD,DWORD);

	// Attributes
	protected:
		HFONT m_hFont;
		HMENU m_hMenu;
		MyString m_title;

		LPFNDLLFUNC1 dllfunc_GradientFill;
		HINSTANCE hinst_msimg32;
		long clRight;
		long clLeft;
		long clText;
		bool bDrawEdge;
		UINT flag_edge;

	protected:
		bool m_bCanDoGradientFill;
		HFONT CreatePopupMenuTitleFont();
		BOOL GradientFill(	HDC hdc,
							CONST PTRIVERTEX pVertex,
							DWORD dwNumVertex,
							CONST PVOID pMesh,
							DWORD dwNumMesh,
							DWORD dwMode);
		


	// Implementation
	public:
		CMyMenu();

		void AddTitle(char *title);
		void operator= (HMENU hMenu) { m_hMenu = hMenu; };

		void SetColor(long cl) {clLeft=cl;};
		void SetGradientColor(long cl) {clRight=cl;};
		void SetTextColor(long cl) {clText=cl;};
		// See ::DrawEdge for flag values
		void SetEdge(bool shown,UINT remove=0,UINT add=0) {bDrawEdge=shown; (flag_edge^=remove)|=add;};

		long GetColor() {return clLeft;};
		long GetGradientColor() {return clRight;};
		long GetTextColor() {return clText;};
		long GetEdge() {return flag_edge;};

		virtual ~CMyMenu();
		virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMIS);
		virtual void DrawItem(LPDRAWITEMSTRUCT lpDIS);

	private: 
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TITLEMENU_H__E69DD9C2_0FDA_11D6_9385_0060086FAC36__INCLUDED_)

