#if !defined(AFX_MYRECT_H__C61C6B64_4171_4BA7_971C_CC9255370B75__INCLUDED_)
#define AFX_MYRECT_H__C61C6B64_4171_4BA7_971C_CC9255370B75__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// ***************************************************************************************

class CMySize
{
	public:
		int dx;
		int dy;

		CMySize()
		{
			Reset();
		}

		CMySize(int xdx,int xdy)
		{
			Set(xdx,xdy);
		}

		void Reset()
		{
			dx = dy = 0;
		}

		void operator=(CMySize *s)
		{
			dx = s->dx;
			dy = s->dy;
		}

		void operator=(CMySize &s)
		{
			operator=(&s);
		}
	
		void Set(int xdx,int xdy)
		{
			dx = xdx;
			dy = xdy;
		}
};

// ***************************************************************************************

class CMyRect  
{
	public:
		RECT r;
		
		CMyRect()
		{
			Reset();
		}

		void Reset()
		{
			r.top = r.bottom = r.left = r.right = 0;
		}
		operator RECT() const
		{
			return r;
		}

		void operator=(CMyRect *n)
		{
			r.top = n->r.top;
			r.bottom = n->r.bottom;
			r.left = n->r.left;
			r.right = n->r.right;
		}

		void operator=(CMyRect &r)
		{
			operator=(&r);
		}
	
		void Set(int left,int right,int top,int bottom)
		{
			r.top =top;
			r.bottom = bottom;
			r.right = right;
			r.left = left;
		}

		void SetPos(int left,int top)
		{
			r.left = left;
			r.top = top;
		}

		void SetDelta(int dx,int dy)
		{
			r.right=r.left+dx;
			r.bottom = r.top+dy;
		}

		void Translate(int dx,int dy)
		{
			r.right+=dx;
			r.left+=dx;
			r.top+=dy;
			r.bottom+=dy;
		}
		
		int DeltaX()
		{
			return r.right-r.left;
		}

		int DeltaY()
		{
			return r.bottom-r.top;
		}

		BOOL IsInside(POINT *p)
		{
			return IsInside(p->x,p->y);
		}

		BOOL IsInside(int x,int y)
		{
			return x>=r.left && x<=r.right && y>=r.top && y<=r.bottom ? TRUE: FALSE;
		}
};

// ***************************************************************************************

#endif // !defined(AFX_MYRECT_H__C61C6B64_4171_4BA7_971C_CC9255370B75__INCLUDED_)
