#if !defined(AFX_BUFFERING_H__83257F59_D206_411F_AB95_D99685ECCD2D__INCLUDED_)
#define AFX_BUFFERING_H__83257F59_D206_411F_AB95_D99685ECCD2D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include <wingdi.h>

/* *************************************************************************************
	Structure qui fonctionne correctement mais n'acelere pas les acces par
	rapport a GetRValue(color) par ex
************************************************************************************* */
/*
typedef union {
	struct  
	{
		UCHAR red;
		UCHAR green;
		UCHAR blue;
		UCHAR unused;
	} rgb;
	COLORREF color;
} MyColor;
*/

// ***************************************************************************************

class CMyScreen
{
	public:
		CMyScreen();
		virtual ~CMyScreen();

		int			GetPixelIndex(int x, int y);

		COLORREF	GetPixel(int x,int y);
		COLORREF	GetPixel(int index);

		void		SetPixel(int x, int y,UCHAR red,UCHAR green,UCHAR blue);
		void		SetPixel(int x, int y,COLORREF color);

		void		SetPixel(int index,COLORREF color); 
		void		SetPixel(int index,UCHAR red,UCHAR green,UCHAR blue);


		long		GetHeigth() { return m_heigth+1; }
		long		GetWidth()	{return m_width; }

		BOOL		CopyToBuffer	(HWND hWndTemp=NULL);
		BOOL		CopyToBuffer	(HDC hDC,int dx,int dy);
		BOOL		CopyToBuffer_Slow (HDC hDC,int dx,int dy); // sans acceleration

		BOOL		CopyToScreen();

	private:
		void		PreCompute();

		UCHAR *m_buffer;
		long m_heigth;
		long m_width;
		long m_sum;
};

#endif // !defined(AFX_BUFFERING_H__83257F59_D206_411F_AB95_D99685ECCD2D__INCLUDED_)
