#include <windows.h>

#include "MySpin.h"
#include "MyControl.h"
#include "commctrl.h"

// ***************************************************************************************

LRESULT SpinParentCallBack (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam,ULONG ptrContext)
{
	CMySpin *spin = (CMySpin *) ptrContext;
	switch (message)
	{ 
		case WM_HSCROLL:
			if ((HWND)lParam == (HWND)*spin)
			{
				if (LOWORD(wParam) == SB_THUMBPOSITION) 
				{
					SendMessage(hDlg,WM_COMMAND,spin->GetDlgCtrlID(),HIWORD(wParam));
					return TRUE;
				}
			}
			break;
	}

	return FALSE;
}

// ***************************************************************************

CMySpin::CMySpin(HWND hWnd) : CMyControl(hWnd)
{
	subParent.Set(SpinParentCallBack,(LONG)this);
	SetRang(0,0);
	SetPos(0);
}

// ***************************************************************************

CMySpin::~CMySpin()
{

}

// ***************************************************************************

void CMySpin::SetRang(int min,int max)
{
	m_min = min;
	m_max = max;
	SendMessage(UDM_SETRANGE32,min,max);
}

// ***************************************************************************

void CMySpin::SetPos(int pos)
{
	SendMessage(UDM_SETPOS,1, MAKELONG (pos, 0));
}

// ***************************************************************************

int CMySpin::GetPos()
{
	return LOWORD(SendMessage(UDM_GETPOS,0,0));

}

// ***************************************************************************
