#include <windows.h>

#include "MySubClassing.h"

CMyList<CElemSubClassing> m_lElemSubClassing;

// ***********************************************************************************

CMySubClassing::CMySubClassing()
{
	m_isSubclassing = FALSE;
}

// ***********************************************************************************

CMySubClassing::~CMySubClassing()
{
	Delete();
}

// ***********************************************************************************

void CMySubClassing::operator=(HWND hWnd)
{
	// verifie si la hWnd n'est pas deja dans la list des element deja sous class
	// sinon creer une entre
	// mes a jour le ptr sur l'element courent quelque soit le cas
	BOOL isFind=FALSE;
	for (m_lElemSubClassing=0;m_lElemSubClassing.More();m_lElemSubClassing++)
	{
		CElemSubClassing * elem = m_lElemSubClassing.GetElemPtr();
		if (elem->m_hWndControl==hWnd) 
		{
			m_elemSubClassingCurrent = elem;
			isFind = TRUE;
			break;
		}
	}
	if (!isFind)
	{
		CElemSubClassing elem;
		elem.m_hWndControl = hWnd;
		elem.m_oldCallBack = GetWindowLong(hWnd,GWL_WNDPROC);
		m_lElemSubClassing.AddLast(elem);
		m_elemSubClassingCurrent = m_lElemSubClassing.GetElemPtr();
	}
	//Delete(); // atraiter: supression de l'element en cours
	m_isSubclassing = FALSE;
}

// ***********************************************************************************

void CMySubClassing::Delete()
{
	if (m_isSubclassing)
	{
		//SetWindowLong (m_elemSubClassingCurrent->m_hWndControl,GWL_WNDPROC,m_oldCallBack);
		m_isSubclassing = FALSE;
	}
}

// ***********************************************************************************
#include "ClientDebug.h"
CClientDebug debugSub;
#include "MyString.h"
CMyString tmp;

LRESULT CALLBACK CallBackSubClassing (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	CMySubClassing *sub = (CMySubClassing *) GetProp(hWnd,"SubClassing");
	if (!sub) return FALSE;

	// applique les sous-classements
	CMyList<CElemCallback> *lElemCallBack = &sub->m_elemSubClassingCurrent->m_lElemCallBack;
	for (lElemCallBack->GoFirst();lElemCallBack->More();lElemCallBack->GoNext())
	{
		CElemCallback *elem = lElemCallBack->GetElemPtr();
		BOOL isEnd;
		LRESULT result = elem->m_callBack(hWnd,message,wParam,lParam,elem->m_ptrContext,&isEnd);
		if (isEnd) return result; // s'arret si un sous classement le dit
	}
	return CallWindowProc((WNDPROC)sub->m_elemSubClassingCurrent->m_oldCallBack,hWnd,message,wParam,lParam);
}

// ***********************************************************************************

void CMySubClassing::Set(PTR_FONCTION_CALLBACK newCallBack,ULONG ptrContext)
{
	m_isSubclassing = TRUE;

	CElemCallback elemCB;
	elemCB.m_callBack=newCallBack;
	elemCB.m_ptrContext	= ptrContext;
	m_elemSubClassingCurrent->m_lElemCallBack.AddFirst(elemCB);

	SetProp(m_elemSubClassingCurrent->m_hWndControl,"SubClassing",(HANDLE)this);
	SetWindowLong(m_elemSubClassingCurrent->m_hWndControl,GWL_WNDPROC,(LONG)CallBackSubClassing);
}

// ***********************************************************************************

