/* SubClassing ***************************************************************
	Cette class permet de sous-classer plusieur fois une fenetre

	Ex.:
	typedef struct { int x,y; char name[1024]; }  TInfo1;
	typedef struct { COLORREF rgb; BOOL isTransparent; } TInfo2;

	LRESULT MyNewCallBack2 (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam,ULONG ptrContext)
	{
		TInfo2 *info = (TInfo2 *)ptrContext;
		switch (message)
			//...
	}

	LRESULT MyNewCallBack1 (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam,ULONG ptrContext)
	{
		TInfo1 *info = (TInfo1 *)ptrContext;
		switch (message)
			//...
	}
	
	void main()
	{   //...
		TInfo1 info1;
		TInfo2 info2;
		CMySubClassing sub;
		sub= hWnd;
		sub.Set(newCallBack1,&info1);
		sub.Set(newCallBack2,&info2);
		//...
	}
************************************************************************ */

#if !defined(AFX_MYSUBCLASSING_H__B19BE954_67F7_440E_8025_C08A1AFE37B7__INCLUDED_)
#define AFX_MYSUBCLASSING_H__B19BE954_67F7_440E_8025_C08A1AFE37B7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyList.h"

typedef LRESULT (*PTR_FONCTION_CALLBACK) (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam,ULONG ptrContext,BOOL *isEnd);

class CElemCallback
{
	public:
		PTR_FONCTION_CALLBACK m_callBack;
		ULONG m_ptrContext;

		CElemCallback()
		{
			m_callBack = 0;
			m_ptrContext = 0;
		}

		void operator=(CElemCallback &elem)
		{
			m_callBack = elem.m_callBack;
			m_ptrContext = elem.m_ptrContext;
		}
};

class CElemSubClassing
{
	public:
		HWND m_hWndControl;
		ULONG m_oldCallBack;
		MyList<CElemCallback> m_lElemCallBack;

		CElemSubClassing() 
		{
			m_hWndControl = 0;
			m_oldCallBack = 0;
			m_lElemCallBack.SuprAll();
		}

		void operator=(CElemSubClassing &elem)
		{
			m_hWndControl = elem.m_hWndControl;
			m_oldCallBack = elem.m_oldCallBack;
			m_lElemCallBack = elem.m_lElemCallBack;
		}
};

/* Structure de doonne: *****************************************************
  	m_lElemSubClassing[](CElemSubClassing)
  	  m_hWndControl		(HWND)
	  m_oldCallBack		(ULONG)
	  m_lElemCallBack[]	(CElemCallback)
	  	m_callBack		(PTR_FONCTION_CALLBACK)
	  	m_ptrContext	(ULONG)
*************************************************************************** */

class CMySubClassing  
{
	private:
		BOOL m_isSubclassing;
		
	public:
		CElemSubClassing *m_elemSubClassingCurrent;

		CMySubClassing();
		virtual ~CMySubClassing();

		void operator=(HWND hWnd);

		void Set(PTR_FONCTION_CALLBACK newCallBack,ULONG ptrContext);
		void Delete ();
};

#endif // !defined(AFX_MYSUBCLASSING_H__B19BE954_67F7_440E_8025_C08A1AFE37B7__INCLUDED_)
