#include <windows.h>
#include "MyToolTip.h"
#include "MyControl.h"

// *************************************************************************************

BOOL CMyToolTip::operator =(HWND hWnd) //Initialise le controle
{	
	m_hWndParent=hWnd;
	m_hInstance= (HINSTANCE) GetWindowLong(hWnd,GWL_HINSTANCE);

	if (m_hWndToolTip) DestroyWindow(m_hWndToolTip);
	m_hWndToolTip = CreateWindowEx(0L, TOOLTIPS_CLASS, NULL,
		WS_POPUP,
		CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT,
		m_hWndParent, NULL, m_hInstance,
		NULL);
	if (!m_hWndToolTip) return FALSE;
	
	if(!SetWindowPos(m_hWndToolTip,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE))
		return FALSE;

	if(!SendMessage(m_hWndToolTip,TTM_ACTIVATE,TRUE,0L)) return FALSE;
	return TRUE;
}

// *************************************************************************************

BOOL CMyToolTip::Add(char *text,UINT control) 
{
	memset(&m_toolTipStruct, 0x0, sizeof(m_toolTipStruct));
	m_toolTipStruct.cbSize = sizeof(m_toolTipStruct);
	m_toolTipStruct.uFlags = TTF_SUBCLASS|TTF_IDISHWND;
	m_toolTipStruct.hwnd = (HWND)GetDlgItem(m_hWndParent, control);
	m_toolTipStruct.uId = (WPARAM)m_toolTipStruct.hwnd;
	m_toolTipStruct.lpszText = text;
	m_toolTipStruct.hinst = m_hInstance;
	
	if(!SendMessage(m_hWndToolTip, TTM_ADDTOOL, 0, (LPARAM)&m_toolTipStruct)) return FALSE;
	return TRUE;
}

// *************************************************************************************

BOOL CMyToolTip::SetWidth(int maxWidth)
{
	return SendMessage(m_hWndToolTip, TTM_SETMAXTIPWIDTH,0,maxWidth)?TRUE:FALSE;   
}

// *************************************************************************************

BOOL CMyToolTip::SetTime(int initTime,int reShowTime,int autoPopTime)
{
	if (autoPopTime!=-1)
		SendMessage(m_hWndToolTip,TTM_SETDELAYTIME,TTDT_AUTOPOP,MAKELONG(autoPopTime,0));
	if (initTime!=-1)
		SendMessage(m_hWndToolTip,TTM_SETDELAYTIME,TTDT_INITIAL,MAKELONG(initTime,0));
	if (reShowTime!=-1)
		SendMessage(m_hWndToolTip,TTM_SETDELAYTIME,TTDT_RESHOW,MAKELONG(reShowTime,0));
	return TRUE;
}

//******************//
//Dans WM_INITDIALOG//
//******************//
/*
CMyToolTip TT; // Initialisation du controle
TT = hDlg;
TT.Add("ToolTip1",BUTTON_OK); // Ajout du ToolTip "ToolTip1" au controle (Boutton dans ce cas) BUTTON_OK 
*/