#include <windows.h>
#include <stdio.h>
#include "MyControl.h"
#include "MyTree.h"

// ***************************************************************************************
LRESULT TreeCallBack (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam,ULONG ptrContext,BOOL *isEnd)
{
	CMyTree *tree = (CMyTree*) ptrContext;
	*isEnd=FALSE;
/*
	switch (message)
	{
		case WM_KILLFOCUS: return TRUE;
		
		  case WM_MOUSEMOVE:
			if (!tree->IsFocus()) tree->SetFocus();
			break;

	}
*/
	return 0;
}

// ***************************************************************************************

LRESULT TreeParentCallBack (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam,ULONG ptrContext,BOOL *isEnd)
{
	CMyTree *tree = (CMyTree*) ptrContext;
	*isEnd=FALSE;
	switch (message)
	{		
		case WM_NOTIFY:
			{
				int result;
				*isEnd = tree->Notify(lParam,&result);
				if (*isEnd) return result;
			}
			break;
	}
	return 0;
}

// ***************************************************************************************

CMyTree::CMyTree(HWND hwndMaster,int x,int y,int dx,int dy,int optionalIdControl)
:CMyControl(hwndMaster)
{
	InitCommonControls();
	
	m_controlID = optionalIdControl;
	DWORD dwStyle = WS_TABSTOP | WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_FULLROWSELECT | TVS_SHOWSELALWAYS;
	DWORD dwStyleEx = WS_EX_TRANSPARENT ;
	m_hWndControl = CreateWindowEx( 
		dwStyleEx,WC_TREEVIEW,"",dwStyle,
		x,y,dx,dy,
		GetHWND(),NULL,GethInstance(),NULL);

	scroll.Init(m_hWndControl);
	Init();
}

CMyTree::CMyTree()
{
	m_controlID = 0;
}

CMyTree::CMyTree(HWND hWndTree)
{
	operator=(hWndTree);
}

void CMyTree::operator=(HWND hWndTree)
{
	CMyControl *control = (CMyControl *)this;
	*control = hWndTree;	
	m_controlID = GetDlgCtrlID();
	Init();
}

// *************************************************************************************

void CMyTree::Init()
{
	m_isNextCheck = FALSE;

	m_isFirstAdd = TRUE;
	m_hCurrentItem = NULL;

	SetLineColor (GetSysColor(COLOR_WINDOWTEXT),GetSysColor(COLOR_WINDOW));
	SetHightLightColor (GetSysColor(COLOR_HIGHLIGHTTEXT),GetSysColor(COLOR_HIGHLIGHT));
	SetHightLightColorUnFocus(GetSysColor(COLOR_HIGHLIGHTTEXT),GetSysColor(COLOR_HIGHLIGHT));

	SetFullRawSelect(FALSE);
	//SubClassing(TreeCallBack);
	subParent.Set(TreeParentCallBack,(LONG)this);
}

// *************************************************************************************

#include "clientDebug.h"
//CClientDebug debug;

//#define DEBUG_NOTIFY(text) debug.SendEvent("tree",text);
//#define DEBUG_NOTIFY2(text) debug.SendLine("tree",text);
#define DEBUG_NOTIFY(text) ;
#define DEBUG_NOTIFY2(text) ;

BOOL CMyTree::Notify(LPARAM lParam,int *result)
{
	ENotifyTree eNotify=TreeNothing;
	result=0;

	LPNMHDR pnmh = (LPNMHDR) lParam; 
	if (pnmh->hwndFrom != m_hWndControl) return TreeNothing;

	LPNMTREEVIEW pnmtv = (LPNMTREEVIEW) lParam;
	TVITEM elemTree;
	GetCursorPos(&m_position);

	static BOOL isRepaint = FALSE; // avoir ==> variable de methode ?

	switch (pnmh->code)
	{
		case TVN_SELCHANGING:
			DEBUG_NOTIFY("TVN_SELCHANGING");
			m_isNextCheck = TRUE;
			eNotify=TreeSelChanging;
			break;

		case TVN_SELCHANGED:
			DEBUG_NOTIFY("TVN_SELCHANGED");
			m_isNextCheck = TRUE;
			eNotify=TreeSelChanged;
			break;

		case TVN_ITEMEXPANDING: 
			DEBUG_NOTIFY("TVN_ITEMEXPANDING");			
			m_isNextCheck = FALSE;
			eNotify=TreeItemExpanding;
			break;

		case NM_CLICK:
			DEBUG_NOTIFY("NM_CLICK");
			m_isNextCheck = TRUE;
			eNotify=TreeClick;
			break;

		case NM_SETCURSOR:
			if (m_isNextCheck)
			{
				RECT rect;
				GetWindowRect(&rect);

				TVHITTESTINFO ht;
				ht.pt.x = m_position.x - rect.left;
				ht.pt.y = m_position.y - rect.top;
					
				m_hCurrentItem = HitTest(&ht);
				if (m_hCurrentItem)
				{
					// veification if the changing is valide
					// Prepare to receive the desired information.
					elemTree.mask = TVIF_HANDLE | TVIF_STATE;
					elemTree.hItem = m_hCurrentItem;
					elemTree.stateMask = TVIS_STATEIMAGEMASK;

					// Request the information.
					GetItem(&elemTree);
					//isNextCheck = FALSE;

					if (ht.flags==TVHT_ONITEMICON) 
					{ // on a click sur l'icon donc: check / uncheck
						if (elemTree.lParam == FALSE) 
						{	
							DEBUG_NOTIFY("TreeSetCursorOnIcon");			
							m_isNextCheck = FALSE;
							eNotify=TreeSetCursorOnIcon;
							break;
						}

						BOOL state = GetCheckState(m_hCurrentItem);
						SetCheckState(m_hCurrentItem,!state);
					}
					//lse //if (elemTree.lParam == FALSE) return TreeSetCursor;

				}
				m_isNextCheck = FALSE;
			}
			eNotify=TreeSetCursor;
			break;

		case TVN_BEGINLABELEDIT:
			DEBUG_NOTIFY("TVN_BEGINLABELEDIT");			
			eNotify=TreeBeginLabelEdit;
			break;

		case TVN_BEGINRDRAG: 
			DEBUG_NOTIFY("TVN_BEGINRDRAG");			
			eNotify=TreeBeginRDrag;
			break;

		case TVN_DELETEITEM: 
			DEBUG_NOTIFY("TVN_DELETEITEM");			
			eNotify=TreeDeleteItem;
			break;

		case TVN_ENDLABELEDIT: 
			DEBUG_NOTIFY("TVN_ENDLABELEDIT");			
			eNotify=TreeEndLabelEdit;
			break;

		case TVN_GETDISPINFO: 
			DEBUG_NOTIFY("TVN_GETDISPINFO");			
			eNotify=TreeGetDispInfo;
			break;

		case TVN_GETINFOTIP: 
			DEBUG_NOTIFY("TVN_GETINFOTIP");			
			eNotify=TreeGetInfoTip;
			break;

		case TVN_ITEMEXPANDED: 
			DEBUG_NOTIFY("TVN_ITEMEXPANDED");			
			eNotify=TreeItemExpanded;
			break;

		case NM_DBLCLK:
			DEBUG_NOTIFY("NM_DBLCLK");			
			eNotify=TreeDblClk; 
			break;

		case NM_KILLFOCUS:
			DEBUG_NOTIFY("NM_KILLFOCUS");						
			eNotify=TreeKillFocus;
			break;

		case NM_RCLICK: 
			DEBUG_NOTIFY("NM_RCLICK");			
			eNotify=TreeRClick;
			break;

		case NM_RETURN: 
			DEBUG_NOTIFY("NM_RETURN");			
			eNotify=TreeReturn;
			break;

		case NM_SETFOCUS:
			DEBUG_NOTIFY("NM_SETFOCUS");			
			eNotify=TreeSetFocus;
			break;

		case TVN_KEYDOWN: 
			DEBUG_NOTIFY("TVN_KEYDOWN");			
			eNotify=TreeKeyDown;
			break;

		case TVN_SETDISPINFO:
			DEBUG_NOTIFY("TVN_SETDISPINFO");			
			eNotify=TreeSetDispInfo;
			break;

		case TVN_SINGLEEXPAND:
			DEBUG_NOTIFY("TVN_SINGLEEXPAND");			
			eNotify=TreeSingleExpand;
			break;

		case NM_CUSTOMDRAW: // changement de la taille d'un colone
			DEBUG_NOTIFY("NM_CUSTOMDRAW");			
		    result = CDRF_DODEFAULT;
		    eNotify=TreeCustomDraw;

			LPNMTVCUSTOMDRAW cd = (LPNMTVCUSTOMDRAW)lParam;
			int iRow = cd->nmcd.dwItemSpec;
			HTREEITEM hItem = (HTREEITEM) cd->nmcd.dwItemSpec;
			
			switch (cd->nmcd.dwDrawStage)
			{
				case CDDS_PREPAINT:
					DEBUG_NOTIFY2("CDDS_PREPAINT");			
					*result = CDRF_NOTIFYITEMDRAW;
					break;

				case CDDS_ITEMPREPAINT:
					DEBUG_NOTIFY2("CDDS_ITEMPREPAINT");			
					  switch (cd->nmcd.uItemState)
					  {
							case CDIS_FOCUS+CDIS_SELECTED: // button down
								DEBUG_NOTIFY2("  CDIS_FOCUS+CDIS_SELECTED");			
								cd->clrText   = m_textColorHi; // Use my foreground hilite color
								cd->clrTextBk = m_backgroundColorHi; // Use my background hilite color
								if (m_isFullRawSelected)
								{
									HBRUSH hBrush = CreateSolidBrush(m_backgroundColorHi);
									HBRUSH hOldBrush = (HBRUSH) SelectObject(cd->nmcd.hdc,hBrush);
									Rectangle(cd->nmcd.hdc,cd->nmcd.rc.left,cd->nmcd.rc.top-1,cd->nmcd.rc.right,cd->nmcd.rc.bottom);
									SelectObject(cd->nmcd.hdc,hOldBrush);
									DeleteObject(hBrush);
								}
								break;
								
							case CDIS_SELECTED:	// refresh
								DEBUG_NOTIFY2("  CDIS_SELECTED");			
								cd->clrText   = m_textColorHiUf; // Use my foreground hilite color
								cd->clrTextBk = m_backgroundColorHiUf; // Use my background hilite color
								if (m_isFullRawSelected)
								{
									HBRUSH hBrush = CreateSolidBrush(m_backgroundColorHiUf);
									HBRUSH hOldBrush = (HBRUSH) SelectObject(cd->nmcd.hdc,hBrush);
									Rectangle(cd->nmcd.hdc,cd->nmcd.rc.left,cd->nmcd.rc.top-1,cd->nmcd.rc.right,cd->nmcd.rc.bottom);
									SelectObject(cd->nmcd.hdc,hOldBrush);
									DeleteObject(hBrush);
								}
								break;
								
							default:
								DEBUG_NOTIFY2("  Default");			
								cd->clrText   = m_textColor; // Use my foreground color
								cd->clrTextBk = m_backgroundColor; // Use my background color
					  }					  
					  break;
			}
			break;
			
	}
	if (eNotify!=TreeNothing) ::SendMessage(GetParent(),WM_COMMAND,GetControlID(),eNotify);
	return FALSE;
}

// *************************************************************************************

BOOL CMyTree::SetCheckState(HTREEITEM hItem, BOOL fCheck)
{
    TVITEM tvItem;

    tvItem.mask = TVIF_HANDLE | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
    tvItem.hItem = hItem;
	tvItem.iImage = fCheck; 
	tvItem.iSelectedImage = fCheck; 
    tvItem.stateMask = TVIS_STATEIMAGEMASK;

    /*
    Since state images are one-based, 1 in this macro turns the check off, and 
    2 turns it on.
    */
    tvItem.state = INDEXTOSTATEIMAGEMASK((fCheck ? 1 : 0));


    return SetItem(&tvItem);
}

// *************************************************************************************

BOOL CMyTree::GetCheckState(HTREEITEM hItem)
{
    TVITEM tvItem;

    // Prepare to receive the desired information.
    tvItem.mask = TVIF_HANDLE | TVIF_STATE;
    tvItem.hItem = hItem;
    tvItem.stateMask = TVIS_STATEIMAGEMASK;

    // Request the information.
    GetItem(&tvItem);

    // Return zero if it's not checked, or nonzero otherwise.
    return ((BOOL)(tvItem.state >> 12) ); // -1
}

// *************************************************************************************

void CMyTree::ExpandAll (BOOL expand,BOOL treeing)
{
	ExpandAll(expand,treeing,m_hFirstItem);
}

void CMyTree::ExpandAll (BOOL expand,BOOL treeing,HTREEITEM rootTree)
{
	while (rootTree)
	{
		Expand(rootTree,expand);
		if (treeing) ExpandAll(expand,treeing,GetChildItem(rootTree));
		rootTree = GetNextItem(rootTree);
	} 
}

// *************************************************************************************

void CMyTree::Expand (HTREEITEM hItem,BOOL expand)
{
	TreeView_Expand(m_hWndControl,hItem,expand? TVE_EXPAND : TVE_COLLAPSE);
}

// *************************************************************************************

BOOL CMyTree::InitCheck(DWORD idCheckOff,DWORD idCheckOn,DWORD idCheckOther,int dx,int dy)
{
	m_isCheck = TRUE;
	m_isNextCheck = FALSE;

	// init les images
	HIMAGELIST himl;  // handle to image list 
	HBITMAP hbmp;     // handle to bitmap 
	HINSTANCE hInst = GethInstance();

	// Create the image list. 
	if ((himl = ImageList_Create(dx, dy, FALSE, 1, 0)) == NULL) return FALSE; 

	// Add the open file, closed file, and document bitmaps. 

	if (idCheckOff)
	{
		hbmp = LoadBitmap(hInst, MAKEINTRESOURCE(idCheckOff)); 
		ImageList_Add(himl, hbmp, (HBITMAP) NULL); 
		DeleteObject(hbmp); 
	}

	if (idCheckOn)
	{
		hbmp = LoadBitmap(hInst, MAKEINTRESOURCE(idCheckOn)); 
		ImageList_Add(himl, hbmp, (HBITMAP) NULL); 
		DeleteObject(hbmp); 
	}

	if (idCheckOther)
	{
		hbmp = LoadBitmap(hInst, MAKEINTRESOURCE(idCheckOther)); 
		ImageList_Add(himl, hbmp, (HBITMAP) NULL); 
		DeleteObject(hbmp); 
	}

	// Fail if not all of the images were added. 
	//if (ImageList_GetImageCount(himl) != 3) return FALSE; 

	// Associate the image list with the tree view control. 
	TreeView_SetImageList(m_hWndControl, himl, TVSIL_NORMAL); 
	return TRUE;
}

// **************************************************************************************

HTREEITEM CMyTree::Add(HTREEITEM hParent,char *text,BOOL isChecking)
{
	return Add(hParent,TVI_LAST,text,isChecking);
}

/* **************************************************************************************
	hInsertAfter peut etre handle ou 
		TVI_FIRST Inserts the item at the beginning of the list. 
		TVI_LAST Inserts the item at the end of the list. 
		TVI_ROOT Add the item as a root item. 
		TVI_SORT Inserts the item into the list in alphabetical order. 

************************************************************************************** */

HTREEITEM CMyTree::Add(HTREEITEM hParent,HTREEITEM hInsertAfter,char *text,BOOL isChecking)
{
	TVINSERTSTRUCT elemTree;
	elemTree.hInsertAfter = hInsertAfter;							
	elemTree.item.mask = TVIF_TEXT | TVIF_PARAM;
	elemTree.hParent = hParent;
	elemTree.item.pszText = text;
	elemTree.item.lParam = isChecking;

	HTREEITEM hItem = TreeView_InsertItem(m_hWndControl,&elemTree);

	if (m_isFirstAdd) { m_hFirstItem = hItem; m_isFirstAdd = FALSE; }
	return hItem;
}

// *************************************************************************************

void CMyTree::DeleteAllItems()
{
	TreeView_DeleteAllItems(m_hWndControl);
	m_isFirstAdd = TRUE;
}

// *************************************************************************************

BOOL CMyTree::GetItem(TVITEM *elemTree)
{
	return TreeView_GetItem(m_hWndControl,elemTree);
}

// *************************************************************************************

HTREEITEM CMyTree::GetItem(int xPos,int yPos)
{
	TVHITTESTINFO  ht;
	ht.pt.x = xPos;
	ht.pt.y = yPos;

	return HitTest(&ht);
}

// *************************************************************************************

BOOL CMyTree::SetItem(TVITEM *elemTree)
{
	return TreeView_SetItem(m_hWndControl,elemTree);
}

// *************************************************************************************

HTREEITEM CMyTree::HitTest(TVHITTESTINFO *ht)
{
	return TreeView_HitTest(m_hWndControl,ht);
}

// *************************************************************************************

HTREEITEM CMyTree::GetNextItem(HTREEITEM hItem)
{
	return TreeView_GetNextSibling(m_hWndControl,hItem);
}

// *************************************************************************************

HTREEITEM CMyTree::GetChildItem(HTREEITEM hItem)
{
	return TreeView_GetNextItem(m_hWndControl,hItem,TVGN_CHILD);
}

// *************************************************************************************

BOOL CMyTree::GetItemText(HTREEITEM hItem,char *text)
{
    TVITEM tvItem;

    // Prepare to receive the desired information.
    tvItem.mask = TVIF_HANDLE | TVIF_TEXT;
    tvItem.hItem = hItem;
	tvItem.cchTextMax = MAX_PATH*2;
	tvItem.pszText = text;

    // Request the information.
    return GetItem(&tvItem);
}

// *************************************************************************************

BOOL CMyTree::DeleteItem(HTREEITEM hItem)
{
	return TreeView_DeleteItem(m_hWndControl,hItem);
}

// *************************************************************************************

BOOL CMyTree::SetCurrentItem(HTREEITEM hitem)
{
	m_hCurrentItem = hitem;
	return TreeView_SelectItem(GetHWND(),hitem);
}

// *************************************************************************************

int CMyTree::GetItemHeight()
{
	return TreeView_GetItemHeight(GetHWND());
}

// *************************************************************************************

int CMyTree::SetItemHeight(int height)
{
	return TreeView_SetItemHeight(GetHWND(),height);
}

// *************************************************************************************

BOOL TreeView_InitCheck(HWND hWndTree,DWORD idCheckOff,DWORD idCheckOn,DWORD idCheckOther,int dx,int dy)
{
	// init les images
	HIMAGELIST himl;  // handle to image list 
	HBITMAP hbmp;     // handle to bitmap 
	HINSTANCE hInst = (HINSTANCE) GetWindowLong(hWndTree,GWL_HINSTANCE);


	// Create the image list. 
	if ((himl = ImageList_Create(dx, dy, FALSE, 2, 0)) == NULL) return FALSE; 

	// Add the open file, closed file, and document bitmaps. 

	if (idCheckOff)
	{
		hbmp = LoadBitmap(hInst, MAKEINTRESOURCE(idCheckOff)); 
		ImageList_Add(himl, hbmp, (HBITMAP) NULL); 
		DeleteObject(hbmp); 
	}

	if (idCheckOn)
	{
		hbmp = LoadBitmap(hInst, MAKEINTRESOURCE(idCheckOn)); 
		ImageList_Add(himl, hbmp, (HBITMAP) NULL); 
		DeleteObject(hbmp); 
	}

	if (idCheckOther)
	{
		hbmp = LoadBitmap(hInst, MAKEINTRESOURCE(idCheckOther)); 
		ImageList_Add(himl, hbmp, (HBITMAP) NULL); 
		DeleteObject(hbmp); 
	}

	// Fail if not all of the images were added. 
	if (ImageList_GetImageCount(himl) < 2) return FALSE; 

	// Associate the image list with the tree view control. 
	TreeView_SetImageList(hWndTree, himl, TVSIL_NORMAL); 
	return TRUE;
}

// *************************************************************************************

BOOL TreeView_SetCheckState2(HWND hwndTreeView, HTREEITEM hItem, BOOL fCheck)
{
    TVITEM tvItem;

    tvItem.mask = TVIF_HANDLE | TVIF_STATE | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
    tvItem.hItem = hItem;
	tvItem.iImage = fCheck; 
	tvItem.iSelectedImage = fCheck; 
    tvItem.stateMask = TVIS_STATEIMAGEMASK;

    /*
    Since state images are one-based, 1 in this macro turns the check off, and 
    2 turns it on.
    */
    tvItem.state = INDEXTOSTATEIMAGEMASK((fCheck ? 1 : 0));

    return TreeView_SetItem(hwndTreeView, &tvItem);
}

// *************************************************************************************

BOOL TreeView_GetCheckState2(HWND hwndTreeView, HTREEITEM hItem)
{
    TVITEM tvItem;

    // Prepare to receive the desired information.
    tvItem.mask = TVIF_HANDLE | TVIF_STATE;
    tvItem.hItem = hItem;
    tvItem.stateMask = TVIS_STATEIMAGEMASK;

    // Request the information.
    TreeView_GetItem(hwndTreeView, &tvItem);

    // Return zero if it's not checked, or nonzero otherwise.
    return ((BOOL)(tvItem.state >> 12) ); // -1
}

// *************************************************************************************

void TreeView_ExpandAll (HWND hTree,HTREEITEM hFirstTree,BOOL expand)
{
	TreeView_GetChild()
	HTREEITEM rootTree = hFirstTree;
	while (rootTree)
	{
		TreeView_Expand(hTree,rootTree,expand? TVE_EXPAND : TVE_COLLAPSE);
		rootTree = TreeView_GetNextSibling(hTree,rootTree);
	} 
}

// ***************************************************************************************

void CMyTree::SetHightLightColor(COLORREF textColor,COLORREF backgroundColor)
{
	m_textColorHi = textColor;
	m_backgroundColorHi = backgroundColor;
}

// ***************************************************************************************

void CMyTree::GetHightLightColor(COLORREF *textColor,COLORREF *backgroundColor)
{
	if (textColor) *textColor = m_textColor;
	if (backgroundColor) *backgroundColor= m_backgroundColor;
}

// ***************************************************************************************

void CMyTree::SetHightLightColorUnFocus(COLORREF textColor,COLORREF backgroundColor)
{
	m_textColorHiUf = textColor;
	m_backgroundColorHiUf = backgroundColor;
}

// ***************************************************************************************

void CMyTree::GetHightLightColorUnFocus(COLORREF *textColor,COLORREF *backgroundColor)
{
	if (textColor) *textColor = m_textColor;
	if (backgroundColor) *backgroundColor= m_backgroundColor;
}

// ***************************************************************************************

void CMyTree::SetLineColor(COLORREF textColor,COLORREF backgroundColor)
{
	m_textColor = textColor;
	m_backgroundColor = backgroundColor;
}

// ***************************************************************************************

void CMyTree::GetLineColor(COLORREF *textColor,COLORREF *backgroundColor)
{
	if (textColor) *textColor = m_textColor;
	if (backgroundColor) *backgroundColor= m_backgroundColor;
}

// ***************************************************************************************
