#if !defined(AFX_MYTREE_H__4251C668_CB43_489B_86C7_94BFBB962EE8__INCLUDED_)
#define AFX_MYTREE_H__4251C668_CB43_489B_86C7_94BFBB962EE8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <commctrl.h> // pour InitCommonControls
#include <windowsx.h> // pour les Edit_SetText et autre ...

BOOL TreeView_SetCheckState2(HWND hwndTreeView, HTREEITEM hItem, BOOL fCheck);
BOOL TreeView_GetCheckState2(HWND hwndTreeView, HTREEITEM hItem);
void TreeView_ExpandAll (HWND hTree,HTREEITEM hFirstTree,BOOL expand);
BOOL TreeView_InitCheck(HWND hWndTree,DWORD idCheckOff,DWORD idCheckOn,DWORD idCheckOther,int dx,int dy);

typedef enum _ENotifyTree
{
	TreeNothing,
	TreeSelChanging,
	TreeSelChanged,
	TreeItemExpanding,
	TreeClick,
	TreeSetCursor,
	TreeSetCursorOnIcon,
	TreeBeginLabelEdit,
	TreeBeginRDrag,
	TreeDeleteItem, 
	TreeEndLabelEdit,
	TreeGetDispInfo,
	TreeGetInfoTip,
	TreeItemExpanded,
	TreeCustomDraw,
	TreeDblClk,
	TreeKillFocus,
	TreeRClick,
	TreeReturn, 
	TreeSetFocus,
	TreeKeyDown, 
	TreeSetDispInfo,
	TreeSingleExpand
} ENotifyTree;

#include "MyControl.h"

class CMyTree : public CMyControl
{
	private:
		BOOL		m_isNextCheck;
		BOOL		m_isCheck;
		BOOL		m_isFirstAdd;

		COLORREF	m_textColor;		
		COLORREF 	m_backgroundColor;
		COLORREF	m_textColorHi;		
		COLORREF 	m_backgroundColorHi;
		COLORREF	m_textColorHiUf;		
		COLORREF 	m_backgroundColorHiUf;

		BOOL		m_isFullRawSelected;
		int			m_controlID;

		void		Init();

	public:
		POINT		m_position;
		HTREEITEM	m_hFirstItem;
		HTREEITEM	m_hCurrentItem;

	public:
		CMyTree();
		CMyTree(HWND hWndTree);
		CMyTree(HWND hwndMaster,int x,int y,int dx,int dy,int optionalControlID=0);

		virtual ~CMyTree() {};

		void operator=(HWND hWndTree);

		BOOL InitCheck(DWORD idCheckOff,DWORD idCheckOn,DWORD idCheckOther,int dx=16,int dy=16);
		BOOL GetCheckState(HTREEITEM hItem);
		BOOL SetCheckState(HTREEITEM hItem, BOOL fCheck);
	
		BOOL SetItem(TVITEM *elemTree);
		BOOL GetItem(TVITEM *elemTree);
		HTREEITEM GetItem(int xPos,int yPos);

		BOOL GetItemText(HTREEITEM hItem,char *text);

		HTREEITEM HitTest(TVHITTESTINFO *ht);

		HTREEITEM Add(HTREEITEM hParent,char *text,BOOL isChecking=FALSE);
		HTREEITEM Add(HTREEITEM hParent,HTREEITEM hInsertAfter,char *text,BOOL isChecking);

		void DeleteAllItems();
		BOOL DeleteItem(HTREEITEM hItem);

		HTREEITEM GetNextItem (HTREEITEM hItem);
		HTREEITEM GetChildItem(HTREEITEM hItem);

		void Expand (HTREEITEM hItem,BOOL expand);
		void ExpandAll (BOOL expand,BOOL treeing=TRUE);
		void ExpandAll (BOOL expand,BOOL treeing,HTREEITEM rootTree);

		BOOL Notify(LPARAM lParam,int *result);

		HTREEITEM GetCurrentItem() { return m_hCurrentItem; }
		BOOL SetCurrentItem(HTREEITEM hitem);

		int GetItemHeight();
		int SetItemHeight(int height=-1);

		void SetHightLightColor			(COLORREF textColor,COLORREF backgroudColor);
		void SetHightLightColorUnFocus	(COLORREF textColor,COLORREF backgroudColor);
		void SetLineColor				(COLORREF textColor,COLORREF backgroudColor);

		void GetHightLightColor			(COLORREF *textColor,COLORREF *backgroundColor);
		void GetHightLightColorUnFocus	(COLORREF *textColor,COLORREF *backgroundColor);
		void GetLineColor				(COLORREF *textColor,COLORREF *backgroundColor);

		void SetFullRawSelect(BOOL set) { m_isFullRawSelected = set; }
		int	GetControlID() { return m_controlID; }

};

#endif // !defined(AFX_MYTREE_H__4251C668_CB43_489B_86C7_94BFBB962EE8__INCLUDED_)
