#if !defined(AFX_MYTITLE_H__576943B9_AFCC_4E19_837F_D8A5CFCBDFA1__INCLUDED_)
#define AFX_MYTITLE_H__576943B9_AFCC_4E19_837F_D8A5CFCBDFA1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// *************************************************************************************

typedef enum _ETypeControl
{
	control_nothing=-1,control_check,control_button
} ETypeControl; 

class CMyEmulatedControl
{
	public:
		ETypeControl type;
		int dx;
		int dy;
		BOOL state,pushed;
		HBITMAP hBitmapOn,hBitmapOff;
		int idCtrl;

		CMyEmulatedControl()
		{
			type=control_nothing;
			dx=-1;
			dy=-1;
			state=FALSE;
			pushed=FALSE;
			hBitmapOn=hBitmapOff;
			idCtrl = -1;
		}

		void operator=(CMyEmulatedControl &source)
		{
			type = source.type;
			dx = source.dx;
			dy = source.dy;
			state = source.state;
			pushed = source.pushed;
			hBitmapOn = source.hBitmapOn;
			hBitmapOff = source.hBitmapOff;
			idCtrl = source.idCtrl;
		}		
};

// *************************************************************************************

#include "MyList.h"
#include "MyControl.h"

class CMyWindow : public CMyControl
{
	public:
		BOOL m_mbClickDown;
		MyList<CMyEmulatedControl> m_titleControls;
	
	public:
		CMyWindow();
		virtual ~CMyWindow();
		void operator=	(HWND hWnd);

		void NcTitlePaint	(UINT message, WPARAM wParam, LPARAM lParam);

		int  AddTitleCheck	(long idCtrl,int deltaX,int deltaY,int idBitmapOn,int idBitmapOff);
		int  AddTitleButton	(long idCtrl,int deltaX,int deltaY,int idBitmapOn,int idBitmapOff);
		
		void DeleteTitleControls();

		void CalculateTitleCaptionTextRect(RECT *prc);
		int  GetTitleButtonNumber(POINT *p);
		BOOL IsTitleCloseBoxVisible();
};

#endif // !defined(AFX_MYTITLE_H__576943B9_AFCC_4E19_837F_D8A5CFCBDFA1__INCLUDED_)
