#include "stdafx.h"
#include "resource.h"

#include <wtypes.h>
#include <commctrl.h> // ne pas oublier la comctl32.lib 
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>


/* **************************************************************************************
	Ex: Button Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char editText[1024];
	static WPARAM id;

	switch (message)
	{
		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDOK:
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
			}
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: Radio Control
************************************************************************************** */

LRESULT CALLBACK MainProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int choice;
	static int id;

	switch (message)
	{
		case WM_INITDIALOG:
			choice = 1;
			Button_SetCheck(GetDlgItem (hDlg,IDC_RADIO_1),TRUE);
			return TRUE;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDC_RADIO_1:
					choice = 1;
					break;

				case IDC_RADIO_2:
					choice = 2;
					break;
			}
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: ComboBox Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static WPARAM id;

	switch (message)
	{
		case WM_INITDIALOG:
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO));
			ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO),"val 1");
			ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO),"val 2");
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO),0);
			return TRUE;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDC_BUTTON_NB_INFO:
					int nb;
					nb= ComboBox_GetCount(GetDlgItem(hDlg,IDC_COMBO))
					return TRUE;

				case IDC_BUTTON_SELECTED:
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO,0))
					return TRUE;

				default : 
					switch (HIWORD(wParam)) 
					{
						case LBN_SELCHANGE :
							num = ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO))
							ComboBox_GetLBText(GetDlgItem(hDlg,IDC_COMBO,num,editText))
							return TRUE;
					} 
			}
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: Spin Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			// init de la spin box
			SendMessage ( GetDlgItem (hDlg, IDC_SPIN), UDM_SETPOS,1, MAKELONG (posBegin, 0) );
			SendMessage ( GetDlgItem (hDlg, IDC_SPIN), UDM_SETRANGE32,posLow,posHight );
			return TRUE;

		case WM_VSCROLL: // spin vertical
		case WM_HSCROLL: // spin horizontal
			if ((HWND)lParam == GetDlgItem (hDlg, IDC_SPIN_CUR))
			{
				if ((int) LOWORD(wParam) == SB_THUMBPOSITION) 
				{
					num = (short int) HIWORD(wParam);
					sprintf(temp,"%d",num);
					Static_SetText(GetDlgItem (hDlg,IDC_STATIC_CURRENT),temp);
				}
			}
			break;
	}
    return FALSE;
}



/* **************************************************************************************
	Ex: ListBox Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char editText[1024];
	static WPARAM id;

	switch (message)
	{
		case WM_INITDIALOG:
			// int la list box
			ListBox_ResetContent(GetDlgItem (hDlg,IDC_LIST));
			ListBox_AddString(GetDlgItem (hDlg,IDC_LIST),"something 1");
			return TRUE;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				default : 
					switch (HIWORD(wParam)) 
					{
						case LBN_SELCHANGE :
							num  = ListBox_GetCurSel((HWND)lParam);
							ListBox_SetCurSel(GetDlgItem(hDlg,IDC_LIST_VARIABLE),num);
							ListBox_GetText(GetDlgItem(hDlg,IDC_LIST_VARIABLE),numChamp,temp);
							break;
					} 
			}
			break;
	}
    return FALSE;
}



/* **************************************************************************************
	Ex: EditBox Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char editText[1024];
	static WPARAM id;

	switch (message)
	{
		case WM_INITDIALOG:
			// init de la text box
			strcpy(editText,"nothing");
			Edit_SetText(GetDlgItem (hDlg,IDC_EDIT_TEXT),editText);
			return TRUE;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDC_EDIT_TEXT:
					Edit_GetText(GetDlgItem (hDlg,id),editTest,1024);
					break;
			}
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: TreeView Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HWND hWndTree;
	static HTREEITEM rootTree[300],tempTree;
	static LPNMHDR pnmh;

	switch (message)
	{
		case WM_INITDIALOG:
			InitCommonControls(); 
			hWndTree = GetDlgItem(hDlg,IDC_TREE);
			return TRUE;

		case WM_NOTIFY:
			{
				id = wParam;
				pnmh = (LPNMHDR) lParam; 
				LPNMTREEVIEW pnmtv = (LPNMTREEVIEW) lParam;
				switch (id)
				{
					case IDC_TREE:
						switch (pnmh->code)
						{
							case TVN_SELCHANGING:
								int i;
								for (i=0;i<300;i++) 
									if (rootTree[i] == pnmtv->itemNew.hItem) break;

								sprintf(temp,"le num %d a changer",i);
								break;
						}
						break;
				}
			}
			break;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDC_BUTTON_GET_ITEM:
					{
						char value[1024];
						TV_ITEM item;
						item.hItem = rootTree[num];
						item.mask = TVIF_TEXT;
						item.pszText = value;
						item.cchTextMax = 1024;
						TreeView_GetItem (hWndTree, &item);
					}
					break;

				case IDC_BUTTON_SET_ITEM:
					{
						char value[1024];
						strcpy (value,"new value");
						TV_ITEM item;
						item.hItem = rootTree[num];
						item.mask = TVIF_TEXT ;
						item.pszText = value;
						TreeView_SetItem(hWndTree,&item);
					}
					break;
					
				case IDC_BUTTON_INSERT:
					{
						// insertion dans l'arbre
						TVINSERTSTRUCT elemTree;
						elemTree.hParent = rootTree[num];
						elemTree.hInsertAfter = TVI_LAST;							
						elemTree.item.mask = TVIF_TEXT ;
						sprintf(temp,"Elem %d",num);
						elemTree.item.pszText = temp;
						hWndNewTree = TreeView_InsertItem(hWndTree,&elemTree);
					}
					break;

				case IDC_BUTTON_CLEAR:
					TreeView_DeleteAllItems(hWndTree);
					break;

			}
			break;
	}
    return FALSE;
}

/* **************************************************************************************
	Ex: TabCtrl Control
************************************************************************************** */
#include "tabCtrl.h"

LRESULT CALLBACK Tab1Proc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
        case WM_DESTROY: // avant de quiter sauve les params le cas echeant
			break;
	}
}

LRESULT CALLBACK TabProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CTabCtrl *tab;

	switch (message)
	{
        case WM_NOTIFY: 
			switch (wParam)
			{
				case IDC_TAB:
					if (tab->Notify(lParam))
					{
						// changement de visualisation de la table
					}
					break;
			}
			break;

		case WM_INITDIALOG:
			tab = new CTabCtrl(GetDlgItem(hDlg,IDC_TAB));

			HWND hWndChild;

			hWndChild = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG_TAB1),hDlg,(DLGPROC)Tab1Proc);
			tab->Add(hWndChild,"onglet1");
			hWndChild = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG_TAB2),hDlg,(DLGPROC)Tab2Proc);
			tab->Add(hWndChild,"onglet1");
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case ID_BUTTON_OK:
				case ID_BUTTON_CANCEL:
					delete tab;
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
			}
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: Progress Control
************************************************************************************** */

LRESULT CALLBACK ExProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HWND hWndProgress;

	switch (message)
	{
		case WM_INITDIALOG:
			InitCommonControls(); 
			hWndProgress = GetDlgItem(hDlg,IDC_PROGRESS);

			// initialise la bar de progression
			SendMessage(hWndProgress, PBM_SETPOS, newPos, 0); 
			SendMessage(hWndProgress, PBM_SETRANGE, 0, MAKELPARAM(minRang, maxRang)); 
			SendMessage(hWndProgress, PBM_SETSTEP, (WPARAM) nStepInc, 0); 			
			return TRUE;

		case WM_COMMAND:
			id = LOWORD(wParam);
			switch (id)
			{
				case IDC_BUTTON_EX:
					SendMessage(hWndProgress, PBM_STEPIT, 0, 0); // on progresse
					break;
			}
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: ListView (wrapper par ma CListView)  preference du control list: "owner data"
************************************************************************************** */
#include "listView.h"
// InitCommonControls() dois deja etre lanc

LRESULT CALLBACK MainProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char temp[1024];
	static WPARAM id;
	static CListView *list;

	switch (message)
	{
		case WM_INITDIALOG:
			list = new CListView(GetDlgItem (hDlg,IDC_LIST));
			list->AddColumn("Column1",50);
			list->AddColumn("Column2",150);
			list->NbCount(2);			
			return TRUE;

		case WM_NOTIFY:
			{
				LVITEM *result;
				result = list->Notify(lParam);
				if (result)
				{
					switch (result->iSubItem)
					{
						case 0: //Column1
							sprintf(temp); 
							break;

						case 1: //Column2
							sprintf(temp); 
							break;
					}
					strcpy(result->pszText, temp);
				}
			return TRUE;

		case WM_TIMER:
			list->Refresh();
			break;
	}
    return FALSE;
}


/* **************************************************************************************
	Ex: Proc : passage de parametre
************************************************************************************** */

typedef struct
{

} TExParam;

LRESULT CALLBACK ExProc (HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TExParam *param = (TExParam *) GetWindowLong ( hWnd, GWL_USERDATA ) ;

	// parsing des messages
	switch (uMsg) 
	{
		case WM_INITDIALOG:
			param = (TExParam *) ((LPCREATESTRUCT)lParam)->lpCreateParams ; // pour WM_CREATE
			param = (TExParam *) lParam; // pour dialog
			SetWindowLong ( hDlg, GWL_USERDATA , (LONG)param) ;
			return TRUE;
	}
	return FALSE;
}


/* **************************************************************************************
	Ex: WinMain
************************************************************************************** */

#include "stdafx.h"
#include "resource.h"
#include <commctrl.h> // pour InitCommonControls
#include <windowsx.h> // pour les Edit_SetText et autre ...

#pragma comment(lib, "comctl32.lib") // en .NET

HINSTANCE hInst;

LRESULT CALLBACK MainProc (HWND , UINT , WPARAM , LPARAM );

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	hInst = hInstance;
	LoadLibrary("riched32.dll");
	InitCommonControls(); // ajouter "comctl32.lib" dans les settings
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_MAIN),NULL,(DLGPROC) MainProc);
	return TRUE;
}


/* **************************************************************************************
	Utils
************************************************************************************** */

// affiche une dialog non bloquante avec param
HWND hWnd;
hWnd = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_DIALOG),NULL,(DLGPROC) ExProc ,(long)&param);
ShowWindow(hWnd , SW_SHOW);


//pour avoir acces a ReadDirectoryChangesW
// isserer dans "stdafx.h"
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#define _WIN32_WINNT 0x0400

// Lecture de DLL et attachement du pointeur / fonction ***********************************
// prototypage
typedef TYPE_RETURNVALUE (* TPrototyFonction1) (TYPE_PARAM1,TYPE_PARAM2);

// pointeur du fonction dans varaible global
TPrototyFonction1 fonction1;

// chargement
HANDLE hDll = LoadLibrary("myDLL.dll");
if (hDll) 
{
	// attachement du pointeur de fonction avec la DLL
	fonction1 = (TPrototyFonction1)GetProcAddress(hDll, "NomeDeLaFonction");
}
else 
{
	MessageBox(NULL,"Erreur","Ouverture DLL",0);
	exit(0);
}
//...
