#include <stdio.h>
#include <windows.h>
#include <shellapi.h>
#include <string.h>
#include <shlwapi.h>

#include "utilsDebug.h"


/* ---------------------------------------------------------------------------------------------------
	Affichage d'un message d'erreur du getlast error
	(! apres avoir utilisez, des-allouer pas LocalFree)

	char *message;
	message = MessageGetLastError();
	MessageBox(NULL,message,"Error / General",0);
	LocalFree(message);
--------------------------------------------------------------------------------------------------- */

void MyMessageBoxGetLastError (char *title)
{
	char *message;
	message = MyMessageGetLastError();
	MessageBox(NULL,message,title,0);
	LocalFree(message);
}

char * MyMessageError(DWORD error)
{	
	char *buffer = NULL;
	if (error == ERROR_SUCCESS) return NULL;

	::FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				error,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &buffer,
				0,
				NULL);

	return buffer;
}

char * MyMessageGetLastError()
{
	return MyMessageError(GetLastError());
}


/* ------------------------------------------------------------------------------------------------------
   Donne la memoire libre 
---------------------------------------------------------------------------------------------------- */

void MyGetMemoryFree (int *freeMem,int *deltaMem)
{
	static int oldAvail = 0;
	MEMORYSTATUS buffer;   

	GlobalMemoryStatus(&buffer);
	*freeMem=(int)buffer.dwAvailPhys;
	*deltaMem = *freeMem - oldAvail;
	oldAvail = *freeMem;
}


/* ------------------------------------------------------------------------------------------------------
   Donne le nom d'un messager passe ne parametre 
---------------------------------------------------------------------------------------------------- */

void MyMessageText(int msg,char *messageTxt)
{
	switch (msg) 
	{
		case WM_NULL: 				strcpy(messageTxt,"WM_NULL"); break; 
		case WM_CREATE: 			strcpy(messageTxt,"WM_CREATE"); break; 
		case WM_DESTROY: 			strcpy(messageTxt,"WM_DESTROY"); break; 
		case WM_MOVE: 				strcpy(messageTxt,"WM_MOVE"); break; 
		case WM_SIZE: 				strcpy(messageTxt,"WM_SIZE"); break; 
		case WM_ACTIVATE: 			strcpy(messageTxt,"WM_ACTIVATE"); break; 
		case WM_SETFOCUS: 			strcpy(messageTxt,"WM_SETFOCUS"); break; 
		case WM_KILLFOCUS: 			strcpy(messageTxt,"WM_KILLFOCUS"); break; 
		case WM_ENABLE: 			strcpy(messageTxt,"WM_ENABLE"); break; 
		case WM_SETREDRAW: 			strcpy(messageTxt,"WM_SETREDRAW"); break; 
		case WM_SETTEXT: 			strcpy(messageTxt,"WM_SETTEXT"); break; 
		case WM_GETTEXT: 			strcpy(messageTxt,"WM_GETTEXT"); break; 
		case WM_GETTEXTLENGTH: 		strcpy(messageTxt,"WM_GETTEXTLENGTH"); break; 
		case WM_PAINT: 				strcpy(messageTxt,"WM_PAINT"); break; 
		case WM_CLOSE: 				strcpy(messageTxt,"WM_CLOSE"); break; 
		case WM_QUERYENDSESSION:	strcpy(messageTxt,"WM_QUERYENDSESSION"); break; 
		case WM_QUIT: 				strcpy(messageTxt,"WM_QUIT"); break; 
		case WM_QUERYOPEN: 			strcpy(messageTxt,"WM_QUERYOPEN"); break; 
		case WM_ERASEBKGND: 		strcpy(messageTxt,"WM_ERASEBKGND"); break; 
		case WM_SYSCOLORCHANGE:		strcpy(messageTxt,"WM_SYSCOLORCHANGE"); break; 
		case WM_ENDSESSION: 		strcpy(messageTxt,"WM_ENDSESSION"); break; 
		case WM_SHOWWINDOW: 		strcpy(messageTxt,"WM_SHOWWINDOW"); break; 
		case WM_WININICHANGE: 		strcpy(messageTxt,"WM_WININICHANGE"); break; 
	//--	case WM_SETTINGCHANGE: 	strcpy(messageTxt,"WM_SETTINGCHANGE"); break; 
		case WM_DEVMODECHANGE: 		strcpy(messageTxt,"WM_DEVMODECHANGE"); break; 
		case WM_ACTIVATEAPP: 		strcpy(messageTxt,"WM_ACTIVATEAPP"); break; 
		case WM_FONTCHANGE: 		strcpy(messageTxt,"WM_FONTCHANGE"); break; 
		case WM_TIMECHANGE: 		strcpy(messageTxt,"WM_TIMECHANGE"); break; 
		case WM_CANCELMODE: 		strcpy(messageTxt,"WM_CANCELMODE"); break; 
		case WM_SETCURSOR: 			strcpy(messageTxt,"WM_SETCURSOR"); break; 
		case WM_MOUSEACTIVATE: 		strcpy(messageTxt,"WM_MOUSEACTIVATE"); break; 
		case WM_CHILDACTIVATE: 		strcpy(messageTxt,"WM_CHILDACTIVATE"); break; 
		case WM_QUEUESYNC: 			strcpy(messageTxt,"WM_QUEUESYNC"); break; 
		case WM_GETMINMAXINFO: 		strcpy(messageTxt,"WM_GETMINMAXINFO"); break; 
		case WM_PAINTICON: 			strcpy(messageTxt,"WM_PAINTICON"); break; 
		case WM_ICONERASEBKGND:		strcpy(messageTxt,"WM_ICONERASEBKGND"); break; 
		case WM_NEXTDLGCTL: 		strcpy(messageTxt,"WM_NEXTDLGCTL"); break; 
		case WM_SPOOLERSTATUS: 		strcpy(messageTxt,"WM_SPOOLERSTATUS"); break; 
		case WM_DRAWITEM: 			strcpy(messageTxt,"WM_DRAWITEM"); break; 
		case WM_MEASUREITEM: 		strcpy(messageTxt,"WM_MEASUREITEM"); break; 
		case WM_DELETEITEM: 		strcpy(messageTxt,"WM_DELETEITEM"); break; 
		case WM_VKEYTOITEM: 		strcpy(messageTxt,"WM_VKEYTOITEM"); break; 
		case WM_CHARTOITEM: 		strcpy(messageTxt,"WM_CHARTOITEM"); break; 
		case WM_SETFONT: 			strcpy(messageTxt,"WM_SETFONT"); break; 
		case WM_GETFONT: 			strcpy(messageTxt,"WM_GETFONT"); break; 
		case WM_SETHOTKEY: 			strcpy(messageTxt,"WM_SETHOTKEY"); break; 
		case WM_GETHOTKEY: 			strcpy(messageTxt,"WM_GETHOTKEY"); break; 
		case WM_QUERYDRAGICON: 		strcpy(messageTxt,"WM_QUERYDRAGICON"); break; 
		case WM_COMPAREITEM: 		strcpy(messageTxt,"WM_COMPAREITEM"); break; 
	//	case WM_GETOBJECT: 			strcpy(messageTxt,"WM_GETOBJECT"); break; 
		case WM_COMPACTING: 		strcpy(messageTxt,"WM_COMPACTING"); break; 
		case WM_COMMNOTIFY: 		strcpy(messageTxt,"WM_COMMNOTIFY"); break; 
		case WM_WINDOWPOSCHANGING: 	strcpy(messageTxt,"WM_WINDOWPOSCHANGING"); break; 
		case WM_WINDOWPOSCHANGED: 	strcpy(messageTxt,"WM_WINDOWPOSCHANGED"); break; 
		case WM_POWER: 				strcpy(messageTxt,"WM_POWER"); break; 
		case WM_COPYDATA: 			strcpy(messageTxt,"WM_COPYDATA"); break; 
		case WM_CANCELJOURNAL: 		strcpy(messageTxt,"WM_CANCELJOURNAL"); break; 
		case WM_NOTIFY: 			strcpy(messageTxt,"WM_NOTIFY"); break; 
		case WM_INPUTLANGCHANGEREQUEST: 		strcpy(messageTxt,"WM_INPUTLANGCHANGEREQUEST"); break; 
		case WM_INPUTLANGCHANGE:	strcpy(messageTxt,"WM_INPUTLANGCHANGE"); break; 
		case WM_TCARD: 				strcpy(messageTxt,"WM_TCARD"); break; 
		case WM_HELP: 				strcpy(messageTxt,"WM_HELP"); break; 
		case WM_USERCHANGED: 		strcpy(messageTxt,"WM_USERCHANGED"); break; 
		case WM_NOTIFYFORMAT: 		strcpy(messageTxt,"WM_NOTIFYFORMAT"); break; 
		case WM_CONTEXTMENU: 		strcpy(messageTxt,"WM_CONTEXTMENU"); break; 
		case WM_STYLECHANGING: 		strcpy(messageTxt,"WM_STYLECHANGING"); break; 
		case WM_STYLECHANGED: 		strcpy(messageTxt,"WM_STYLECHANGED"); break; 
		case WM_DISPLAYCHANGE: 		strcpy(messageTxt,"WM_DISPLAYCHANGE"); break; 
		case WM_GETICON: 			strcpy(messageTxt,"WM_GETICON"); break; 
		case WM_SETICON: 			strcpy(messageTxt,"WM_SETICON"); break; 
		case WM_NCCREATE: 			strcpy(messageTxt,"WM_NCCREATE"); break; 
		case WM_NCDESTROY: 			strcpy(messageTxt,"WM_NCDESTROY"); break; 
		case WM_NCCALCSIZE: 		strcpy(messageTxt,"WM_NCCALCSIZE"); break; 
		case WM_NCHITTEST: 			strcpy(messageTxt,"WM_NCHITTEST"); break; 
		case WM_NCPAINT: 			strcpy(messageTxt,"WM_NCPAINT"); break; 
		case WM_NCACTIVATE: 		strcpy(messageTxt,"WM_NCACTIVATE"); break; 
		case WM_GETDLGCODE: 		strcpy(messageTxt,"WM_GETDLGCODE"); break; 
		case WM_SYNCPAINT: 			strcpy(messageTxt,"WM_SYNCPAINT"); break; 
		case WM_NCMOUSEMOVE: 		strcpy(messageTxt,"WM_NCMOUSEMOVE"); break; 
		case WM_NCLBUTTONDOWN: 		strcpy(messageTxt,"WM_NCLBUTTONDOWN"); break; 
		case WM_NCLBUTTONUP: 		strcpy(messageTxt,"WM_NCLBUTTONUP"); break; 
		case WM_NCLBUTTONDBLCLK: 	strcpy(messageTxt,"WM_NCLBUTTONDBLCLK"); break; 
		case WM_NCRBUTTONDOWN: 		strcpy(messageTxt,"WM_NCRBUTTONDOWN"); break; 
		case WM_NCRBUTTONUP: 		strcpy(messageTxt,"WM_NCRBUTTONUP"); break; 
		case WM_NCRBUTTONDBLCLK: 	strcpy(messageTxt,"WM_NCRBUTTONDBLCLK"); break; 
		case WM_NCMBUTTONDOWN: 		strcpy(messageTxt,"WM_NCMBUTTONDOWN"); break; 
		case WM_NCMBUTTONUP: 		strcpy(messageTxt,"WM_NCMBUTTONUP"); break; 
		case WM_NCMBUTTONDBLCLK: 	strcpy(messageTxt,"WM_NCMBUTTONDBLCLK"); break; 
		case WM_KEYFIRST: 			strcpy(messageTxt,"WM_KEYFIRST"); break; 
	//--	case WM_KEYDOWN: 		strcpy(messageTxt,"WM_KEYDOWN"); break; 
		case WM_KEYUP: 				strcpy(messageTxt,"WM_KEYUP"); break; 
		case WM_CHAR: 				strcpy(messageTxt,"WM_CHAR"); break; 
		case WM_DEADCHAR: 			strcpy(messageTxt,"WM_DEADCHAR"); break; 
		case WM_SYSKEYDOWN: 		strcpy(messageTxt,"WM_SYSKEYDOWN"); break; 
		case WM_SYSKEYUP: 			strcpy(messageTxt,"WM_SYSKEYUP"); break; 
		case WM_SYSCHAR: 			strcpy(messageTxt,"WM_SYSCHAR"); break; 
		case WM_SYSDEADCHAR: 		strcpy(messageTxt,"WM_SYSDEADCHAR"); break; 
		case WM_KEYLAST: 			strcpy(messageTxt,"WM_KEYLAST"); break; 
		case WM_IME_STARTCOMPOSITION: 		strcpy(messageTxt,"WM_IME_STARTCOMPOSITION"); break; 
		case WM_IME_ENDCOMPOSITION: strcpy(messageTxt,"WM_IME_ENDCOMPOSITION"); break; 
		case WM_IME_COMPOSITION: 	strcpy(messageTxt,"WM_IME_COMPOSITION"); break; 
	//--	case WM_IME_KEYLAST: 	strcpy(messageTxt,"WM_IME_KEYLAST"); break; 
		case WM_INITDIALOG: 		strcpy(messageTxt,"WM_INITDIALOG"); break; 
		case WM_COMMAND: 			strcpy(messageTxt,"WM_COMMAND"); break; 
		case WM_SYSCOMMAND: 		strcpy(messageTxt,"WM_SYSCOMMAND"); break; 
		case WM_TIMER: 				strcpy(messageTxt,"WM_TIMER"); break; 
		case WM_HSCROLL: 			strcpy(messageTxt,"WM_HSCROLL"); break; 
		case WM_VSCROLL:			strcpy(messageTxt,"WM_VSCROLL"); break; 
		case WM_INITMENU: 			strcpy(messageTxt,"WM_INITMENU"); break; 
		case WM_INITMENUPOPUP: 		strcpy(messageTxt,"WM_INITMENUPOPUP"); break; 
		case WM_MENUSELECT: 		strcpy(messageTxt,"WM_MENUSELECT"); break; 
		case WM_MENUCHAR:			strcpy(messageTxt,"WM_MENUCHAR"); break; 
		case WM_ENTERIDLE: 			strcpy(messageTxt,"WM_ENTERIDLE"); break; 
	//	case WM_MENURBUTTONUP: 		strcpy(messageTxt,"WM_MENURBUTTONUP"); break; 
	//	case WM_MENUDRAG: 			strcpy(messageTxt,"WM_MENUDRAG"); break; 
	//	case WM_MENUGETOBJECT: 		strcpy(messageTxt,"WM_MENUGETOBJECT"); break; 
	//	case WM_UNINITMENUPOPUP: 	strcpy(messageTxt,"WM_UNINITMENUPOPUP"); break; 
	//	case WM_MENUCOMMAND: 		strcpy(messageTxt,"WM_MENUCOMMAND"); break; 
		case WM_CTLCOLORMSGBOX: 	strcpy(messageTxt,"WM_CTLCOLORMSGBOX"); break; 
		case WM_CTLCOLOREDIT: 		strcpy(messageTxt,"WM_CTLCOLOREDIT"); break; 
		case WM_CTLCOLORLISTBOX: 	strcpy(messageTxt,"WM_CTLCOLORLISTBOX"); break; 
		case WM_CTLCOLORBTN: 		strcpy(messageTxt,"WM_CTLCOLORBTN"); break; 
		case WM_CTLCOLORDLG: 		strcpy(messageTxt,"WM_CTLCOLORDLG"); break; 
		case WM_CTLCOLORSCROLLBAR: 	strcpy(messageTxt,"WM_CTLCOLORSCROLLBAR"); break; 
		case WM_CTLCOLORSTATIC: 	strcpy(messageTxt,"WM_CTLCOLORSTATIC"); break; 
		case WM_MOUSEFIRST: 		strcpy(messageTxt,"WM_MOUSEFIRST"); break; 
	//--	case WM_MOUSEMOVE: 		strcpy(messageTxt,"WM_MOUSEMOVE"); break; 
		case WM_LBUTTONDOWN: 		strcpy(messageTxt,"WM_LBUTTONDOWN"); break; 
		case WM_LBUTTONUP: 			strcpy(messageTxt,"WM_LBUTTONUP"); break; 
		case WM_LBUTTONDBLCLK: 		strcpy(messageTxt,"WM_LBUTTONDBLCLK"); break; 
		case WM_RBUTTONDOWN: 		strcpy(messageTxt,"WM_RBUTTONDOWN"); break; 
		case WM_RBUTTONUP: 			strcpy(messageTxt,"WM_RBUTTONUP"); break; 
		case WM_RBUTTONDBLCLK: 		strcpy(messageTxt,"WM_RBUTTONDBLCLK"); break; 
		case WM_MBUTTONDOWN: 		strcpy(messageTxt,"WM_MBUTTONDOWN"); break; 
		case WM_MBUTTONUP: 			strcpy(messageTxt,"WM_MBUTTONUP"); break; 
		case WM_MBUTTONDBLCLK: 		strcpy(messageTxt,"WM_MBUTTONDBLCLK"); break; 
	//	case WM_MOUSEWHEEL: 		strcpy(messageTxt,"WM_MOUSEWHEEL"); break; 
	//--	case WM_MOUSELAST: 		strcpy(messageTxt,"WM_MOUSELAST"); break; 
	//--	case WM_MOUSELAST: 		strcpy(messageTxt,"WM_MOUSELAST"); break; 
		case WM_PARENTNOTIFY: 		strcpy(messageTxt,"WM_PARENTNOTIFY"); break; 
		case WM_ENTERMENULOOP: 		strcpy(messageTxt,"WM_ENTERMENULOOP"); break; 
		case WM_EXITMENULOOP: 		strcpy(messageTxt,"WM_EXITMENULOOP"); break; 
		case WM_SIZING: 			strcpy(messageTxt,"WM_SIZING"); break; 
		case WM_CAPTURECHANGED: 	strcpy(messageTxt,"WM_CAPTURECHANGED"); break; 
		case WM_MOVING: 			strcpy(messageTxt,"WM_MOVING"); break; 
		case WM_POWERBROADCAST: 	strcpy(messageTxt,"WM_POWERBROADCAST"); break; 
		case WM_MDICREATE: 			strcpy(messageTxt,"WM_MDICREATE"); break; 
		case WM_MDIDESTROY: 		strcpy(messageTxt,"WM_MDIDESTROY"); break; 
		case WM_MDIACTIVATE: 		strcpy(messageTxt,"WM_MDIACTIVATE"); break; 
		case WM_MDIRESTORE: 		strcpy(messageTxt,"WM_MDIRESTORE"); break; 
		case WM_MDINEXT: 			strcpy(messageTxt,"WM_MDINEXT"); break; 
		case WM_MDIMAXIMIZE: 		strcpy(messageTxt,"WM_MDIMAXIMIZE"); break; 
		case WM_MDITILE: 			strcpy(messageTxt,"WM_MDITILE"); break; 
		case WM_MDICASCADE: 		strcpy(messageTxt,"WM_MDICASCADE"); break; 
		case WM_MDIICONARRANGE: 	strcpy(messageTxt,"WM_MDIICONARRANGE"); break; 
		case WM_MDIGETACTIVE: 		strcpy(messageTxt,"WM_MDIGETACTIVE"); break; 
		case WM_MDISETMENU: 		strcpy(messageTxt,"WM_MDISETMENU"); break; 
		case WM_ENTERSIZEMOVE: 		strcpy(messageTxt,"WM_ENTERSIZEMOVE"); break; 
		case WM_EXITSIZEMOVE: 		strcpy(messageTxt,"WM_EXITSIZEMOVE"); break; 
		case WM_DROPFILES: 			strcpy(messageTxt,"WM_DROPFILES"); break; 
		case WM_MDIREFRESHMENU: 	strcpy(messageTxt,"WM_MDIREFRESHMENU"); break; 
		case WM_IME_SETCONTEXT: 	strcpy(messageTxt,"WM_IME_SETCONTEXT"); break; 
		case WM_IME_NOTIFY: 		strcpy(messageTxt,"WM_IME_NOTIFY"); break; 
		case WM_IME_CONTROL: 		strcpy(messageTxt,"WM_IME_CONTROL"); break; 
		case WM_IME_COMPOSITIONFULL:strcpy(messageTxt,"WM_IME_COMPOSITIONFULL"); break; 
		case WM_IME_SELECT: 		strcpy(messageTxt,"WM_IME_SELECT"); break; 
		case WM_IME_CHAR: 			strcpy(messageTxt,"WM_IME_CHAR"); break; 
	//	case WM_IME_REQUEST: 		strcpy(messageTxt,"WM_IME_REQUEST"); break; 
		case WM_IME_KEYDOWN: 		strcpy(messageTxt,"WM_IME_KEYDOWN"); break; 
		case WM_IME_KEYUP: 			strcpy(messageTxt,"WM_IME_KEYUP"); break; 
	//	case WM_MOUSEHOVER: 		strcpy(messageTxt,"WM_MOUSEHOVER"); break; 
	//	case WM_MOUSELEAVE: 		strcpy(messageTxt,"WM_MOUSELEAVE"); break; 
		case WM_CUT:	 			strcpy(messageTxt,"WM_CUT"); break; 
		case WM_COPY: 				strcpy(messageTxt,"WM_COPY"); break; 
		case WM_PASTE:				strcpy(messageTxt,"WM_PASTE"); break; 
		case WM_CLEAR: 				strcpy(messageTxt,"WM_CLEAR"); break; 
		case WM_UNDO: 				strcpy(messageTxt,"WM_UNDO"); break; 
		case WM_RENDERFORMAT: 		strcpy(messageTxt,"WM_RENDERFORMAT"); break; 
		case WM_RENDERALLFORMATS: 	strcpy(messageTxt,"WM_RENDERALLFORMATS"); break; 
		case WM_DESTROYCLIPBOARD: 	strcpy(messageTxt,"WM_DESTROYCLIPBOARD"); break; 
		case WM_DRAWCLIPBOARD: 		strcpy(messageTxt,"WM_DRAWCLIPBOARD"); break; 
		case WM_PAINTCLIPBOARD: 	strcpy(messageTxt,"WM_PAINTCLIPBOARD"); break; 
		case WM_VSCROLLCLIPBOARD:	strcpy(messageTxt,"WM_VSCROLLCLIPBOARD"); break; 
		case WM_SIZECLIPBOARD: 		strcpy(messageTxt,"WM_SIZECLIPBOARD"); break; 
		case WM_ASKCBFORMATNAME: 	strcpy(messageTxt,"WM_ASKCBFORMATNAME"); break; 
		case WM_CHANGECBCHAIN: 		strcpy(messageTxt,"WM_CHANGECBCHAIN"); break; 
		case WM_HSCROLLCLIPBOARD:	strcpy(messageTxt,"WM_HSCROLLCLIPBOARD"); break; 
		case WM_QUERYNEWPALETTE: 	strcpy(messageTxt,"WM_QUERYNEWPALETTE"); break; 
		case WM_PALETTEISCHANGING: 	strcpy(messageTxt,"WM_PALETTEISCHANGING"); break; 
		case WM_PALETTECHANGED: 	strcpy(messageTxt,"WM_PALETTECHANGED"); break; 
		case WM_HOTKEY: 			strcpy(messageTxt,"WM_HOTKEY"); break; 
		case WM_PRINT: 				strcpy(messageTxt,"WM_PRINT"); break; 
		case WM_PRINTCLIENT: 		strcpy(messageTxt,"WM_PRINTCLIENT"); break; 
		case WM_HANDHELDFIRST: 		strcpy(messageTxt,"WM_HANDHELDFIRST"); break; 
		case WM_HANDHELDLAST: 		strcpy(messageTxt,"WM_HANDHELDLAST"); break; 
		case WM_AFXFIRST: 			strcpy(messageTxt,"WM_AFXFIRST"); break; 
		case WM_AFXLAST: 			strcpy(messageTxt,"WM_AFXLAST"); break; 
		case WM_PENWINFIRST: 		strcpy(messageTxt,"WM_PENWINFIRST"); break; 
		case WM_PENWINLAST: 		strcpy(messageTxt,"WM_PENWINLAST"); break; 
		default: strcpy(messageTxt,"!! Erreur !!");
	}
}